# README

I put together an API Proxy that shows, I think, what you are trying to
accomplish. It assigns a payload in one assignmessage, and then uses the payload
in a second policy.

## To invoke

1. To use the proxy you need to deploy it into your environment.  You can do
   that by manually zipping up the apiproxy directory and deploying it with the
   UI, or use a command-line tool like
   [importAndDeploy.js](https://github.com/DinoChiesa/apigee-edge-js/blob/master/examples/importAndDeploy.js)
   or Powershell's
   [Import-EdgeApi](https://github.com/DinoChiesa/Edge-Powershell-Admin/blob/develop/PSApigeeEdge/Public/Import-EdgeApi.ps1)
   or similar, to deploy the proxy.


2. Invoke it like this:
   ```
   ORG=MYORG
   ENV=MyENV
   curl -i https://$ORG-$ENV.apigee.net/logging-example-1/t1
   ```

   This option runs the first `AssignMessage` policy,
   [AM-1](./apiproxy/policies/AM-1.xml), which assigns directly to a variable
   using the new-ish `Template` element.  And then the flow sets the response
   with [AM-Response-1.xml](./apiproxy/policies/AM-Response-1.xml).



3. invoke the second option like this:
   ```
   curl -i https://$ORG-$ENV.apigee.net/logging-example-1/t2
   ```

   This option runs the second `AssignMessage` policy,
   [AM-2](./apiproxy/policies/AM-2.xml), which sets a payload in a new
   message. The flow then sets the response with
   [AM-Response-2.xml](./apiproxy/policies/AM-Response-2.xml).  This is a
   similar approach, but a little more roundabout. This works in OPDK where the
   `Template` element is not yet available.
